#include	<aes.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"filters.h"
#include	"status.h"


void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value);

char *ASCII85Decode(int window, char *input, char *output, unsigned long size, unsigned long *real_size);
char *expand_lzw(int window, char *input, char *output, unsigned long length, unsigned long *length_output);
char *expand_inflate(int window, char *input, char *output, unsigned long max_size_in, unsigned long max_size_out, unsigned long *output_pos);


int Decompress_stream(struct filter *input, int window)
	{
	char *tmp=NULL;
	int i=0;

	if(input->filter_table==NULL)
		return(1);


	while(input->filter_table[i]!=0)
		{
		switch(input->filter_table[i])
			{
			case ASCIIHEXDECODE:
				form_alert(0, "[3][Not implemented compression method...|AsciiHexDecode][Damn]");
				return(0);
				break;
			case ASCII85DECODE:
				tmp = calloc(1, input->input_len+100);		/* The compression ratio is 4:5.
																											But there is a possibility that the output will be longer then 5:4 of the input:
																											See notes in the source....		*/
				ASCII85Decode(window, input->input, tmp, input->input_len, &input->output_len);

				if(input->filter_table[i+1]!=0)
					{
					free(input->input);
					input->input = calloc(1, input->output_len+100);
					input->input_len = input->output_len;
					memcpy(input->input, tmp, input->output_len);
					}
				else
					{
					if(input->output==NULL)
						input->output = calloc(1, input->output_len+100);
					memcpy(input->output, tmp, input->output_len);
					}
				if(tmp)
					free(tmp);
				break;
			case LZWDECODE:
				tmp = calloc(1, 50*input->input_len);
				input->output_len = 0;
				expand_lzw(window, input->input, tmp, input->input_len, &input->output_len);
				input->output = calloc(1, input->output_len+100);
				memcpy(input->output, tmp, input->output_len);
				free(tmp);
				break;
			case FLATEDECODE:
				tmp = calloc(1, 10*input->input_len);
				input->output_len = 0;
				expand_inflate(window, input->input, tmp, input->input_len, 100*input->input_len, &input->output_len);
				input->output = calloc(1, input->output_len+100);
				memcpy(input->output, tmp, input->output_len);
				free(tmp);
				break;
			case RUNLENGTHDECODE:
				form_alert(0, "[3][Not implemented compression method...|RunLengthDecode][Damn]");
				return(0);
				break;
			case CCITTFAXDECODE:
				form_alert(0, "[3][Not implemented compression method...|CCITTFaxDecode][Damn]");
				return(0);
				break;
			case DCTDECODE:
				form_alert(0, "[3][Not implemented compression method...|DCTDecode][Damn]");
				return(0);
				break;
			default:
				form_alert(0, "[3][Unknown compression method...|Unknown][Damn]");
				return(0);
				break;
			}
		i++;
		}
	return(1);
	}



static char *filters_thumbnail[]={			/*	Extra parameters	*/
	"/ASCIIHexDecode",										/*	no								*/
	"/ASCII85Decode",											/*	no								*/
	"/LZWDecode",													/*	yes								*/
	"/FlateDecode",												/*	yes								*/
	"/RunLengthDecode",										/*	no								*/
	"/CCITTFaxDecode",										/*	yes								*/
	"/DCTDecode",													/*	yes								*/
	NULL};



int read_filter(struct files_pdf *file, char *table)
	{
	int i=0, j=0;

	if(file->buffer[file->actual_pos]!='[' && file->buffer[file->actual_pos+1]!='[')
		{
		while(file->buffer[file->actual_pos++]!='/')	;
		file->actual_pos--;
		while(filters_thumbnail[i]!=NULL)
			{
			if(strncmp(&file->buffer[file->actual_pos], filters_thumbnail[i], strlen(filters_thumbnail[i]))==0)
				table[0] = i+1;
			i++;
			}
		}
	else
		{
		while(file->buffer[file->actual_pos]!=']' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\n')
			{
			while(file->buffer[file->actual_pos++]!='/')	;
			file->actual_pos--;
			i=0;
			while(filters_thumbnail[i]!=NULL)
				{
				if(strncmp(&file->buffer[file->actual_pos], filters_thumbnail[i], strlen(filters_thumbnail[i]))==0)
					{
					table[j++] = i+1;
					file->actual_pos+=(strlen(filters_thumbnail[i])+1);
					break;
					}
				i++;
				}
			}
		}

	return(i);
	}
