#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"


char *Read_command(struct files_pdf *);
char *read_command(int );
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_text(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number(int , unsigned int );

BOOLEAN GoBack(struct PDF_Info *info);
BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj);


char *encrypt_commands[]={
		"/Filter",
		"/V",
		"/R",
		"/O",
		"/U",
		"/P",
		0L};


char *filters[]={
		"/Standard",
		0L};


int CheckFilterType(struct files_pdf *file)
	{
	char *line = Read_command(file);

	if(line)
		{
		return(find_command(filters, line));
		}
	else
		{
		return(-1);
		}
	}

/*
BOOL BitTest(ULONG Var_CB,WORD BitNum_CB)
	{
	ULONG DasBit_CB=((Var_CB>>BitNum_CB) & 1L);

	if (DasBit_CB==0)
		return(FALSE);
	else
		return(TRUE);
	}
*/

BOOLEAN CheckBit(int bit, signed long value)
{
	ULONG value_2=((value>>bit) & 1L);

	if(value_2==0)
		return(FALSE);
	else
		return(TRUE);
}


struct Encryption *read_encryption (struct PDF_Info *info, int obj)
{
	struct files_pdf *file = info->file_info;
	char *line;
	struct	Encryption *encrypt=0L;
	int keep_going=1;

	if(encrypt==0L)
		encrypt = calloc (1, sizeof (struct Encryption));

	info->encryption = encrypt;

	GoToObject(info, obj);

	if(encrypt)
		{
		line = Read_line(file);

		while(keep_going!=0)
			{
			switch((keep_going=Command2ID(file, encrypt_commands)))
				{
				case FILTER:
							encrypt->filter = CheckFilterType(file);
							break;

				case ALGORITHM:
							encrypt->algorithm = (int)Read_object_no(file);
							break;

				case REV_NUM:
							encrypt->rev_num = (int)Read_object_no(file);
							break;

				case USER_PASS:
							line = Read_text(file);
							if(line)
								strcpy(encrypt->user_password, line);
							break;

				case FIX_STR:
							line = Read_text(file);
							if(line)
								strcpy(encrypt->fixed_string, line);
							break;

				case PROTECTION:
							encrypt->protection = (int)Read_object_no(file);
							break;
				default:
							break;
				}
			}

		}
	GoBack(info);
	return(encrypt);
	}