#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"


char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

struct Page_tree *read_Page_tree(struct files_pdf *, long *);

extern struct opt options;

extern struct Root_obj *read_root_obj(struct PDF_Trailer *trailer, struct PDF_Info *info);
extern char *types_command[];

struct PDF_Outline_dictionary *read_outline_dict(struct PDF_Info *, int ,int);
struct PDF_Outline_dictionary *read_outline_dict1(struct PDF_Info *, int );

unsigned long Find_Name(struct PDF_Info *, char *);



char *name_tree_commands[]={
		"/Kids",
		"/Names",
		"/Limits",
		NULL};

char *nametree_commands[]={
		"/Dests",
		"/AP",
		"/JavaScript",
		"/Pages",
		"/Templates",
		"/IDS",
		"/URLS",
		NULL};



BOOLEAN Free_NameTree(struct PDF_Info *info)
	{
	struct NameTree *output=info->name_tree;

	if(output)
		{
		if(output->dests)
			{
			if(output->Dests->Kids)
				free(output->Dests->Kids);
			free(output->Dests);
			}
		if(output->ap)
			{
			if(output->AP->Kids)
				free(output->AP->Kids);
			free(output->AP);
			}
		if(output->javascript)
			{
			if(output->JavaScript->Kids)
				free(output->JavaScript->Kids);
			free(output->JavaScript);
			}
		if(output->pages)
			{
			if(output->Pages->Kids)
				free(output->Pages->Kids);
			free(output->Pages);
			}
		if(output->templates)
			{
			if(output->Templates->Kids)
				free(output->Templates->Kids);
			free(output->Templates);
			}
		if(output->ids)
			{
			if(output->IDS->Kids)
				free(output->IDS->Kids);
			free(output->IDS);
			}
		if(output->urls)
			{
			if(output->URLS->Kids)
				free(output->URLS->Kids);
			free(output->URLS);
			}

		free(info->name_tree);
		return(TRUE);
		}
	return(FALSE);
	}



struct name_tree *Load_nametree(struct PDF_Info *info, int obj)
	{
	struct files_pdf *file = info->file_info;
	char *line=NULL;
	struct name_tree *output=NULL;
	int keep_going=1;
	unsigned long temp=0;

	output = calloc (1, sizeof (struct NameTree));

	if(output)
		{
		GoToObject(info, (unsigned int)obj);

	/*	line = Read_line(file);	*/

		while(keep_going!=0 && output!=NULL)
			{
			switch((keep_going=Command2ID(file, name_tree_commands)))
				{
				case NAMETREE_KIDS:
							output->Kids= read_Page_tree(file, NULL);
							break;
				case NAMETREE_LIMITS:
							output->Limits = file->actual_pos;
							break;
				case NAMETREE_NAMES:
							output->Names = file->actual_pos;
							break;
				default:
							break;
				}
			}
		}

	if(output->Limits>0)
		{
		file->actual_pos = output->Limits;
		line = Read_text(file);
		temp = strcspn(&file->buffer[output->Names], "]");
		if(temp>strcspn(&file->buffer[output->Names], line))
			{
			file->actual_pos += strcspn(&file->buffer[output->Names], line);
			}
		}

	return(output);
	}


BOOLEAN Load_NameTree(struct PDF_Info *info, unsigned long obj)
	{
	struct files_pdf *file = info->file_info;
	struct NameTree *output=NULL;
	int keep_going=1;

	output = calloc (1, sizeof (struct NameTree));

	if(output)
		{
		GoToObject(info, (unsigned int)obj);
		Read_line(file);

		while(keep_going!=0 && output!=NULL)
			{
			switch((keep_going=Command2ID(file, nametree_commands)))
				{
				case NAMETREE_DESTS:
							output->dests = 			Read_object_no(file);
							break;
				case NAMETREE_AP:
							output->ap = 					Read_object_no(file);
							break;
				case NAMETREE_JAVA:
							output->javascript = 	Read_object_no(file);
							break;
				case NAMETREE_PAGES:
							output->pages = 			Read_object_no(file);
							break;
				case NAMETREE_TEMPLATES:
							output->templates = 	Read_object_no(file);
							break;
				case NAMETREE_IDS:
							output->ids = 				Read_object_no(file);
							break;
				case NAMETREE_URLS:
							output->urls = 				Read_object_no(file);
							break;
				default:
							break;
				}
			}

		if(output->dests)
			output->Dests = Load_nametree(info, (int)output->dests);
		else
			output->Dests = NULL;

		if(output->ap)
			output->AP = Load_nametree(info, (int)output->ap);
		else
			output->AP = NULL;

		if(output->javascript)
			output->JavaScript = Load_nametree(info, (int)output->javascript);
		else
			output->JavaScript = NULL;

		if(output->pages)
			output->Pages = Load_nametree(info, (int)output->pages);
		else
			output->Pages = NULL;

		if(output->templates)
			output->Templates = Load_nametree(info, (int)output->templates);
		else
			output->Templates = NULL;

		if(output->ids)
			output->IDS = Load_nametree(info, (int)output->ids);
		else
			output->IDS = NULL;

		if(output->urls)
			output->URLS = Load_nametree(info, (int)output->urls);
		else
			output->URLS = NULL;

		info->name_tree = output;


/*
		Find_Name(info, "F10");										/* THIS IS ONLY A TEST with PDFREF.PDF	!!!!!	*/
		Find_Name(info, "G10.1656930");						/* THIS IS ONLY A TEST PDFREF.PDF	!!!!!				*/
*/

		return(TRUE);
		}
	return(FALSE);
	}



unsigned long Find_Name(struct PDF_Info *info, char *name)
	{
	struct files_pdf *file = info->file_info;
	struct name_tree *temp=NULL, *temp1=NULL;
	int i=0;
	unsigned long output=0, temp_l=0;
	char *name2=calloc(1, strlen(name)+2);
	strcpy(name2, name);

	if(info->name_tree!=NULL)								/* Is name dictionary already loaded?		*/
		{
		if(info->name_tree->Dests)
			{
			temp = info->name_tree->Dests;
			}

		if(temp->Kids)
			{
			while(temp->Kids->page_no!=0 && temp->Kids[i].page_no>0)
				{
				temp1 = Load_nametree(info, temp->Kids[i].page_no);

				if(temp1->Names>0)
					{
					file->actual_pos = temp1->Names;
					temp_l = strcspn(&file->buffer[temp1->Names], "]");
					if(temp_l>((unsigned long)strstr(&file->buffer[temp1->Names], name2)-(unsigned long)&file->buffer[temp1->Names]))
						{
						file->actual_pos = temp1->Names;
						file->actual_pos += ((unsigned long)strstr(&file->buffer[temp1->Names], name2)-(unsigned long)&file->buffer[temp1->Names]+strlen(name2)+1);
						output = Read_object_no(file);
						return(output);
						}
					}
				i++;			
				}
			}
		}

	free(name2);
	return(output);
	}