#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"cont_pat.h"
#include	"windinfo.h"


char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);
unsigned long Find_Name(struct PDF_Info *info, char *name);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

extern struct opt options;
extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];

extern struct Root_obj *read_root_obj(struct PDF_Trailer *trailer, struct PDF_Info *info);
extern char *types_command[];

struct PDF_Outline_dictionary *read_outline_dict(struct PDF_Info *, int ,int);
struct PDF_Outline_dictionary *read_outline_dict1(struct PDF_Info *, int );

short show_outline (WIND_INFO *wind_info, short posx, short posy, short miny, short maxy, struct PDF_Outline_dictionary *out_obj, struct PDF_Info *info);
void Display_thumbnails(WIND_INFO *wind_info, short posx, short posy, short miny, short maxy);

extern OBJECT *adr_popup_outline, *adr_last_files, *adr_gotopage, *adr_disp_tree;


char *outline_commands[]={
		"/Type",
		"/First",
		"/Last",
		"/Count",
		NULL};

char *outline_dictionary_commands[]={
		"/Title",
		"/Parent",
		"/Prev",
		"/Next",
		"/First",
		"/Last",
		"/Count",
		"/Dest",
		"/A",
		"/SE",
		NULL};


char *action_dictionary_commands[]={
		"/S",
		"/GoTo",						/*							Go to a destination in the current document.				*/
		"/GoToR",						/*							(Go-to remote) Go to a destination in another document.				*/
		"/Launch",					/*							Launch an application, usually to open a file.				*/
		"/Thread",					/*							Begin reading an article thread.				*/
		"/URI",							/*							Resolve a uniform resource identifier.				*/
		"/Sound",						/*							(PDF 1.2) Play a sound.				*/
		"/Movie",						/*							(PDF 1.2) Play a movie.				*/
		"/Hide",						/*							(PDF 1.2) Set an annotations Hidden flag.				*/
		"/Named",						/*							(PDF 1.2) Execute an action predefined by the viewer application.				*/
		"/SubmitForm",			/*							(PDF 1.2) Send data to a uniform resource locator.				*/
		"/ResetForm",				/*							(PDF 1.2) Set fields to their default values.				*/
		"/ImportData",			/*							(PDF 1.2) Import field values from a file.				*/
		"/JavaScript",			/*							(PDF 1.3) Execute a JavaScript script.				*/
		NULL};


char *GoTo_commands[]={
		"/S",
		"/D",
		NULL};


BOOLEAN Free_Outline_Dictionary(struct PDF_Outline_dictionary *dict)
{
	struct PDF_Outline_dictionary *prev=NULL;

	if(dict)
	{
		while(dict!=NULL)
		{
			if(dict->first)
				Free_Outline_Dictionary(dict->first);

			if(dict->prev!=NULL)
				{
				free(dict->prev);
				dict->prev = NULL;
				}

			if(dict->Title!=NULL)
				free(dict->Title);

			prev = dict;
			dict = dict->next;
		}

		if(prev!=NULL)
			free(prev);
		return(TRUE);
	}
	return(FALSE);
}


BOOLEAN Free_Outline(struct PDF_Outline *first_dict)
{
	struct PDF_Outline_dictionary *act=first_dict->first_object;

	if(act)
	{
		while(act!=NULL)
		{
			Free_Outline_Dictionary(act);
			act=NULL;
		}

		free(first_dict);
		return(TRUE);
	}
	else
	{
		return(FALSE);
	}
}




struct PDF_Outline *read_outline(struct PDF_Info *info)
	{
	struct files_pdf *file = info->file_info;
	struct PDF_Outline *outline=NULL;
	int keep_going=1;

	outline = calloc (1, sizeof (struct PDF_Outline));

	if(outline)
		{
		GoToObject(info, (unsigned int)info->Root_obj->Outlines);

		Read_line(file);

		while(keep_going!=0 && outline!=NULL)
			{
			switch((keep_going=Command2ID(file, outline_commands)))
				{
				case OUTLINE_TYPE:
							outline->Type = Command2ID(file, types_command);
							if(outline->Type!=5)											/* Is this real an outline object?	*/
								{
								x_gem_alert("[3][Error in PDF structure.|Wrong type in the outline][ Hmmm...]", 0L);
								free(outline);
								outline=NULL;
								break;
								}
							break;
				case OUTLINE_FIRST:
							outline->First = Read_object_no(file);
							break;
				case OUTLINE_LAST:
							outline->Last = Read_object_no(file);
							break;
				case OUTLINE_COUNT:
							outline->Count = (int)Read_object_no(file);
							break;
				default:
							break;
				}
			}

		if(outline!=NULL)
			{
			info->Outline = outline;
			if(outline->First && options.work_mode&LOAD_OUTLINE)
				{
				outline->first_object = read_outline_dict(info, (int)outline->First, 1);
				}
			}

		return(outline);
		}
	return(NULL);
}



struct PDF_Outline_dictionary *add_outline_object(struct PDF_Outline_dictionary *first_dict, int modus)
{
	struct PDF_Outline_dictionary *output=NULL, *prev=NULL;

	if(first_dict==NULL)			/* Is there any outline loaded?	*/
	{
		output = calloc (1, sizeof (struct PDF_Outline_dictionary));
		memset(output, 0, sizeof (struct PDF_Outline_dictionary));
	}
	else														/* No, it's the first outline		*/
	{
		output = first_dict;
		while(output!=NULL)						/* Find the last outline		*/
		{
			prev = output;
			output = output->next;
		}

		if(prev->first && modus==0)
		{
			output = prev->first;
			while(output!=NULL)					/* Find the last outline		*/
			{
				prev = output;
				output = output->next;
			}
		}

		output = calloc (1, sizeof (struct PDF_Outline_dictionary));			/* Alloc some memory							*/
		memset(output, 0, sizeof (struct PDF_Outline_dictionary));				/* Erase this memory							*/

		if(modus==0)															/* Add next paragraph			*/
		{
			prev->next = output;																							/* Add the outline to the thread	*/
			output->prev = prev;																							/* Add the previous outline				*/
		}
		else																			/* Add next subparagraph	*/
		{
			prev->first = output;
			output->parent = prev;
		}
		output->next = NULL;
	}
	return(output);
}


struct PDF_Outline_dictionary *Find_prev_level(struct PDF_Outline_dictionary *first_dict, int level)
{
	struct PDF_Outline_dictionary *output=first_dict;

	if(first_dict)
	{
		while(output)
		{
			if(output->level==(level-1))
				return(output);

			if(output->prev)
				output = output->prev;
			else
				output = output->parent;
		}
		return(output);
	}
	else
	{
		return(NULL);
	}
}


static int outline_no;
static struct PDF_Outline_dictionary *output_outline;

struct PDF_Outline_dictionary *Find_outline_no(struct PDF_Outline_dictionary *first_dict, int obj, int type)
{
	struct PDF_Outline_dictionary *output=NULL, *prev=NULL;

	if(type==0)
		{
		outline_no=0;
		output_outline=NULL;
		}

	output = first_dict;
	while(output!=NULL)
		{
		outline_no++;
		if(outline_no>=obj)
			{
			output_outline=output;
			return(output);
			}
		if(output->first && output->opened)
			Find_outline_no(output->first, obj, 1);

		if(output_outline!=NULL)
			return(output_outline);

		prev=output;
		output=output->next;
		}
	return(prev);
}




struct PDF_Outline_dictionary *read_outline_dict(struct PDF_Info *info, int obj_no, int count)
	{
	struct files_pdf *file = info->file_info;
	struct PDF_Outline_dictionary *outline_dict=NULL, *first_dict=NULL, *prev_dict=NULL;
	int objects=-1;								/* Last loaded object					*/
	int level=0, keep_going=1;

	Change_status(STATUS_BAR2_UPDATE, 0, count);

	while(obj_no!=0)
	{
		objects++;

		GoToObject(info, (unsigned int)obj_no);
		obj_no = 0;

		outline_dict = add_outline_object(first_dict, 0);

		if(info->Outline->first_object==NULL)
			info->Outline->first_object = outline_dict;

		outline_dict->level = level;
		if(prev_dict)
		{
			if(prev_dict->level<level)
			{
				outline_dict->prev = prev_dict;
				outline_dict->parent = prev_dict;
			}
		}
		prev_dict = outline_dict;

		if(first_dict==NULL)
			first_dict = outline_dict;

		Read_line(file);

		if(file->buffer[file->actual_pos]=='<')
			file->actual_pos += 2;

		keep_going = 1;

		Change_status(STATUS_BAR2_UPDATE, objects, count);

		while(keep_going!=0)
		{
			switch((keep_going=Command2ID(file, outline_dictionary_commands)))
			{
				case OUTLINE_DICT_TITLE:
							outline_dict->title = file->actual_pos;
							break;
				case OUTLINE_DICT_PARENT:
							outline_dict->Parent = Read_object_no(file);
							break;
				case OUTLINE_DICT_PREV:
							outline_dict->Prev = Read_object_no(file);
							break;
				case OUTLINE_DICT_NEXT:
							outline_dict->Next = Read_object_no(file);
							obj_no = (int)outline_dict->Next;
							break;
				case OUTLINE_DICT_FIRST:
							outline_dict->First = Read_object_no(file);
							break;
				case OUTLINE_DICT_LAST:
							outline_dict->Last = Read_object_no(file);
							break;
				case OUTLINE_DICT_COUNT:
							outline_dict->Count = (int)Read_object_no(file);
							break;
				case OUTLINE_DICT_DEST:			/* TO DO !!!!!!	*/
							outline_dict->Dest = file->actual_pos;
							break;
				case OUTLINE_DICT_A:
							outline_dict->A = file->actual_pos;
							break;
				case OUTLINE_DICT_SE:
							outline_dict->SE = file->actual_pos;
							break;
				default:
							break;
				}
			}
		}

/*	outline_dict = first_dict;
	while(outline_dict!=NULL && (outline_dict->next!=NULL || outline_dict->Count!=0))
		{
		if(outline_dict->First)
			{
			outline_dict->first = read_outline_dict(info, (int)outline_dict->First, (int)outline_dict->Count);
			}
		outline_dict = outline_dict->next;

		if(outline_dict==info->Outline->first_object)
			break;
		}
*/
	GoBack(info);
	return(first_dict);
}



/* *******************************
	THIS ROUTINE SHOULD BE EXTENDED IN THE FUTURE
	********************************	*/

int Make_Action(struct PDF_Info *pdf_info, struct PDF_Outline_dictionary *outline)
	{
	int action=0, output;
	struct files_pdf *file = pdf_info->file_info;
	unsigned long old_pos=file->actual_pos;

	file->actual_pos = outline->A;

	GoToObject(pdf_info, (unsigned int)Read_object_no(file));
	Read_line(file);
	Read_line(file);

	action = Command2ID(file, action_dictionary_commands);

	if(action==1)
		{
		action = Command2ID(file, action_dictionary_commands);

		switch(action)
			{
			case 2:										/* GoTo	*/
				Read_line(file);
											/* Because there are only two _required_ commands 
													we have to proceed it twice	*/
				action = Command2ID(file, GoTo_commands);										/* This can be only 'D' (destination)	*/
				file->actual_pos += 3;
				output = (int)Read_object_no(file);
				GoToObject(pdf_info, (unsigned int)output);
				GoBack(pdf_info);
				break;
			case 3:										/* GoToR	*/
				break;
			}
		}

	file->actual_pos = old_pos;
	return(output);
	}


int Find_Page_Number_by_Outline(struct PDF_Info *pdf_info, struct PDF_Outline_dictionary *outline)
	{
	unsigned long old_pos=0, i=0;
	int output=0, action;
	struct files_pdf *file = pdf_info->file_info;
	char *name=NULL;

	if(outline->Dest!=0)
		{
		old_pos = file->actual_pos;
		file->actual_pos = outline->Dest;
		if(file->buffer[file->actual_pos]=='[' || file->buffer[file->actual_pos+1]=='[')
			{
			while(isdigit(file->buffer[file->actual_pos])==0)
				file->actual_pos++;
			output = (int)Read_object_no(file);
			}
		else if(file->buffer[file->actual_pos]=='(' || file->buffer[file->actual_pos+1]=='(')
			{
			name = Read_text(file);
			output = (int)Find_Name(pdf_info, name);
			GoToObject(pdf_info, (unsigned int)output);

			Read_line(file);
			Read_line(file);
			action = Command2ID(file, GoTo_commands);										/* This can be only 'D' (destination)	*/
			if(action==2)
				{
				file->actual_pos += 3;
				output = (int)Read_object_no(file);
				/*	GoToObject(pdf_info, output);	*/
				}
			}
		else
			output = (int)Read_object_no(file);
		file->actual_pos = old_pos;
		GoBack(pdf_info);
		}
	else if(outline->A!=0)
		{
		output = Make_Action(pdf_info, outline);
		}

	if(outline->SE!=0)
		{
		}

	while(pdf_info->pages[i].page_in_pdf!=output && i<pdf_info->pages->max_to_load)
		i++;

	return((int)i);
	}



	/* display the outline at the left of the window */
int cdecl display_outline (PARMBLK *para)
{
	short x, y, handle, pxy[8], *p;
	WIND_INFO *wind_info;
	struct PDF_Outline *outline=NULL;
	struct PDF_Outline_dictionary *out_obj=NULL;

	handle = x_gem->sys_handle;

	pxy[0] = max (para->pb_x, para->pb_xc);
	pxy[1] = max (para->pb_y, para->pb_yc);
	pxy[2] = min (para->pb_x + para->pb_w - 1, para->pb_xc + para->pb_wc - 1);
	pxy[3] = min (para->pb_y + para->pb_h - 1, para->pb_yc + para->pb_hc - 1);
	vs_clip (handle, 1, pxy);

	vswr_mode (handle, MD_REPLACE);

	vsf_interior (handle, FIS_SOLID);
	vsf_color (handle, WHITE);

	p = pxy;
	*(p ++) = para->pb_x;
	*(p ++) = para->pb_y;
	*(p ++) = para->pb_w + pxy[0] - 1;
	*(p) = para->pb_h + pxy[1] - 1;

	v_bar (handle, pxy);

	wind_info = (WIND_INFO *)((WIND_LIST *)para->pb_parm)->w_user1;
	outline = wind_info->pdf_info->Outline;

	if (outline)
	{
		out_obj = outline->first_object;
		if (out_obj || wind_info->pdf_info->thumb!=NULL)
		{
			x = para->pb_x + 4;
			y = para->pb_y + 4 - wind_info->outline_pos * OUTLINE_HEIGHT;
			wind_info->max_width = 0;
			show_outline (wind_info, x, y, para->pb_y, para->pb_y + para->pb_h, out_obj, wind_info->pdf_info);
			wind_info->max_width -= (para->pb_tree[HBAR_TB].ob_width-3);
		}
	}

	vs_clip (handle, 0, pxy);

	return (0);
}


short show_outline (WIND_INFO *wind_info, short posx, short posy, short miny, short maxy, struct PDF_Outline_dictionary *out_obj, struct PDF_Info *info)
{
	char *line=NULL;
	short x;
	WIND_LIST *wind=NULL;
	OBJECT *adr=NULL;
	/*int attr[10]={0};*/
	unsigned long pos=0;

	wind = &windows[info->window_handle];

	if((wind->w_dial.d_addr[THUMB_TB].ob_state)&SELECTED || out_obj==NULL)
		{
		Display_thumbnails(wind_info, posx, posy, miny, maxy);
		adr = wind->w_dial.d_addr;
/*		x_disable_slide (adr, UP_TB, DOWN_TB, 1, wind_info->outline_number, 1);
		x_init_slider (adr, UP_TB, DOWN_TB, VCUR_TB, VBAR_TB, 1, adr[DTREE_TB].ob_height / 70, wind_info->pdf_info->pages->how_many_thumbnails, 0, 0);
*/
		return(posy);
		}

	if (posy > maxy)
		return (posy);

	do
	{
		if (out_obj->Title == NULL && out_obj->title > 0)
		{
			pos = info->file_info->actual_pos;
			info->file_info->actual_pos = out_obj->title;
			line = Read_text (info->file_info);
			if (line)
			{
				out_obj->Title = calloc (1, strlen (line) + 4);
				strncpy (out_obj->Title, line, strlen (line));
			}
			info->file_info->actual_pos = pos;
		}
		if (posy > miny)
		{
			x = posx - wind_info->outline_pos_x;

			x_draw_icon (adr_disp_tree, out_obj->First ? PARENT_TR : FILE_TR, out_obj->opened ? SELECTED : NORMAL, x - 1, posy - 1, 0L);
			x_small_font (x + 16, posy, out_obj->First ? MF_BOLD : MF_NORMAL, out_obj->opened ? BLUE : BLACK, out_obj->Title);

			if (out_obj->First)
			{
				if (x_small_font_width (1, out_obj->Title) > wind_info->max_width)
					wind_info->max_width = x_small_font_width (1, out_obj->Title);
			}
			else
			{
				if (x_small_font_width (0, out_obj->Title) > wind_info->max_width)
					wind_info->max_width = x_small_font_width (0, out_obj->Title);
			}
		}
		posy += OUTLINE_HEIGHT;

		if (out_obj->first && out_obj->opened)
			posy = show_outline (wind_info, posx + 8, posy, miny, maxy, out_obj->first, info);

		out_obj = out_obj->next;
	} while (out_obj);

	return (posy);
}




short get_outline_number (short n, struct PDF_Outline_dictionary *out_obj)
{
	if (! out_obj)
		return (n);

	do
	{
		n ++;
		if (out_obj->first && out_obj->opened)
			n = get_outline_number (n, out_obj->first);
		if(out_obj->next)
			out_obj = out_obj->next;
		else
			break;
	} while (out_obj);

	return (n);
}