#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"mp_const.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"mypdf.h"


extern OBJECT *adr_strings, *adr_doc_info;
extern X_GEM_INFO *x_gem;
char *suspend_small_text (char *str, short style, short width, short mode);


struct PDF_Trailer *find_trailer(struct PDF_Info *);
char *Read_line (struct files_pdf *);
char *read_prev_line(int );
char *read_first_line(int );
char *Read_text(struct files_pdf *);
char *read_text(int );
int Command2ID(struct files_pdf *, char **);
int load_objects(struct files_pdf );
BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
struct PDF_PageTree *find_page_tree(struct PDF_Info *info, int page_no);
BOOLEAN CheckBit(int bit, signed long value);

extern struct opt options;


#define PDF_INFO_Title					1
#define PDF_INFO_Author					2
#define PDF_INFO_Subject				3
#define PDF_INFO_Keywords				4
#define PDF_INFO_Creator				5
#define PDF_INFO_Producer				6
#define PDF_INFO_CreationDate		7
#define PDF_INFO_ModDate				8
#define PDF_INFO_Trapped				9
#define PDF_INFO_Version				10


char *pdf_info_commands[]={
		"/Title",
		"/Author",
		"/Subject",
		"/Keywords",
		"/Creator",
		"/Producer",
		"/CreationDate",
		"/ModDate",
		"/Trapped",
		"/Version",
		NULL};


char *months[]={"Januar",
								"Februar",
								"March",
								"April",
								"May",
								"June",
								"July",
								"August",
								"September",
								"Oktober",
								"November",
								"December"};


#define MONTH_NAME	x_get_ob_text(adr_strings, MONTHS_JANUARY + month_no)

void Depack_date(char *date, int len)
	{
	char date_tmp[256]={0};
	char year[5]={0}, month[3]={0}, day[3]={0};
	char time[9]={0};
	int month_no=0;

/*	date_tmp = calloc (1, strlen (date) + 5);	*/

	if(strncmp(&date[2], "191", 3)==0)
		{
		year[0] = '2';
		year[1] = '0';
		strncpy(&year[2], 	&date[3+2], 2);
		strncpy(month,	&date[3+4], 2);
		strncpy(day, 		&date[3+6], 2);
		}
	else
		{
		strncpy(year, 	&date[2], 4);
		strncpy(month,	&date[6], 2);
		strncpy(day, 		&date[8], 2);
		}

	if(isdigit(year[0])!=0 && isdigit(month[0])!=0 && isdigit(day[0])!=0)
		{
		if(strncmp(&date[2], "191", 3)==0)
			{
			strncpy(&time[0], &date[11], 2);
			strncpy(&time[3], &date[13], 2);
			strncpy(&time[6], &date[15], 2);
			}
		else
			{
			strncpy(&time[0], &date[10], 2);
			strncpy(&time[3], &date[12], 2);
			strncpy(&time[6], &date[14], 2);
			}
		time[2] = ':';
		time[5] = ':';

		month_no = atoi(month) - 1;

		switch(options.date_type)
			{
			case 0:			/* dd.mm.yyyy	*/
				sprintf(date_tmp, "%s.%s.%s%c", day, month, year, 0);
				break;
			case 1:			/* dd.mm.yy		*/
				sprintf(date_tmp, "%s.%s.%.2s%c", day, month, &year[2], 0);
				break;
			case 2:			/* yyyy.mm.dd	*/
				sprintf(date_tmp, "%s.%s.%s%c", year, month, day, 0);
				break;
			case 3:			/* yy.mm.dd		*/
				sprintf(date_tmp, "%.2s.%s.%s%c", &year[2], month, day, 0);
				break;
			case 4:			/* mm.dd.yyyy	*/
				sprintf(date_tmp, "%s.%s.%s%c", month, day, year, 0);
				break;
			case 5:			/* mm.dd.yy		*/
				sprintf(date_tmp, "%s.%s.%.2s%c", month, day, &year[2], 0);
				break;
			case 6:			/* dd. month name. yyyy	*/
				sprintf(date_tmp, "%s. %s %s%c", day, MONTH_NAME, year, 0);		/*	 months[month_no] */
				break;
			case 7:			/* dd. month name. yy		*/
				sprintf(date_tmp, "%s. %s %.2s%c", day, MONTH_NAME, &year[2], 0);
				break;
			case 8:			/* yyyy. month name. dd	*/
				sprintf(date_tmp, "%s. %s %s%c", year, MONTH_NAME, day, 0);
				break;
			case 9:			/* yy. month name. dd	*/
				sprintf(date_tmp, "%.2s. %s %s%c", &year[2], MONTH_NAME, day, 0);
				break;
			case 10:		/* month name. dd. yyyy	*/
				sprintf(date_tmp, "%s %s.%s%c", MONTH_NAME, day, year, 0);
				break;
			case 11:		/* month name. dd. yy		*/
				sprintf(date_tmp, "%s %s.%.2s%c", MONTH_NAME, day, &year[2], 0);
				break;
		}

		if(len>=strlen(date_tmp))
			{
			strcpy(date, date_tmp);
			date[strlen(date_tmp)] = 0;
			strcat(date, ", ");
			strcat(date, &time[0]);
			}
		else
			strncpy(date, date_tmp, strlen(date));
		}
/*	free(date_tmp);	*/
	}


void Go_to_info_object(struct PDF_Trailer *trailer, struct files_pdf *file)
	{
	if(file->buffer)
		{
		file->actual_pos = trailer->Info_object_position;
		}
	else
		{
		Fseek(trailer->Info_object_position, file->handle, 0);
		}
	}


void Check_differences(char *line)
	{
	int in, out;
	char *output=calloc(1, strlen(line)+1), octal[4]={0};

	for(out=0, in=0; in<strlen(line); in++, out++)
		{
		if(line[in]=='\\' && isdigit(line[in+1])!=0)			/* OCTAL	*/
			{
			in++;
			octal[0] = line[in++];
			if(isdigit(line[in]))
				octal[1] = line[in++];
			if(isdigit(line[in]))
				octal[2] = line[in];
			output[out] = GetCharFromDifference(octal2dec(octal), NULL, 2);
			}
		else
			output[out] = line[in];
		}
	strcpy(line, output);
	free(output);
	}


/* ********************************************************
*	Load_pdf_info v. 1.1 (04.10.2001)												*
***********************************************************
*	1.0 (xx.xx.2001) - First version												*
*	1.1 (04.10.2001) - Added FreeMem												*
*																													*	*/

int Load_pdf_info (struct PDF_Info *pdf_info)
{
	char *line=NULL;		/* The memory for this variable is allocated and
													freed in Read_command()!!!	*/
	struct files_pdf *file = pdf_info->file_info;
	BOOLEAN keep_going=TRUE;

	if (file->handle || file->buffer)
	{
		pdf_info->trailer = find_trailer(pdf_info);


		if(pdf_info->trailer==NULL)
			return(FALSE);

		Change_status(STATUS_PDF_READ_INFO, 0, 0);
		Change_status(STATUS_BAR1_UPDATE, 8, 9);

		GoToObject(pdf_info, (unsigned int)pdf_info->trailer->Info_object);

		while(keep_going!=0)
		{
			switch((keep_going=Command2ID(file, pdf_info_commands)))
			{
				case PDF_INFO_Title:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Title = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Title, line);
					break;
				case PDF_INFO_Author:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Author = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Author, line);
					break;
				case PDF_INFO_Subject:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Subject = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Subject, line);
					break;
				case PDF_INFO_Keywords:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Keywords = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Keywords, line);;
					break;
				case PDF_INFO_Creator:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Creator = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Creator, line);
					break;
				case PDF_INFO_Producer:
					line = Read_text(file);
					Check_differences(line);
					if(line)
						if ((pdf_info->Producer = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Producer, line);
					break;
				case PDF_INFO_CreationDate:
					line = Read_text(file);
					if(line)
						{
						if ((pdf_info->CreationDate = calloc (1, strlen (line) + 20)) > 0L)
							strncpy (pdf_info->CreationDate, line, strlen(line));
						Depack_date(pdf_info->CreationDate, (int)(strlen (line) + 20));
						}
					break;
				case PDF_INFO_ModDate:
					line = Read_text(file);
					if(line)
						{
						if ((pdf_info->ModDate = calloc (1, strlen (line) + 20)) > 0L)
							strcpy (pdf_info->ModDate, line);
						Depack_date(pdf_info->ModDate, (int)(strlen (line) + 20));
						}
					break;
				case PDF_INFO_Trapped:
					line = Read_text(file);
					if(line)
						if ((pdf_info->Trapped = calloc (1, strlen (line) + 1)) > 0L)
							strcpy (pdf_info->Trapped, line);
					break;
				default:
					break;
			}
		}

		if(pdf_info->Trapped==NULL)
			{
			pdf_info->Trapped = calloc(1, strlen(" No "));
			strcpy(pdf_info->Trapped, "No ");
			}
		
		if(file->handle)
			close (file->handle);

		Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_READ_INFO, 0);

		return(1);
		}
	Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_READ_INFO, 0);
	return(0);
}


/* er: big changes ! */
void Show_pdf_info (struct PDF_Info *pdf_info)
{
	char buf[256]={0}, buf2[256]={0}, dummy1[100]={0}, dummy2[100]={0};
	short obj;
	DIAL_INFO dial;
	struct PDF_PageTree *page=pdf_info->pages;

	if(page->MediaBox.x1==page->MediaBox.x2 && page->MediaBox.y1==page->MediaBox.y1 && page->first_kid!=NULL)
		page = page->first_kid;

	strcpy (buf, pdf_info->file_info->name);				/* get file name */
	x_cut_filename (buf);									/* keep the name only */
	sprintf (buf2, STR (DI_NAME), buf);						/* arrange title */
	x_suspend_text (x_gem->sys_handle, buf2 + 3, adr_doc_info[NAME_DI].ob_width, 1);	/* in case name is too long */
	x_set_ob_text (adr_doc_info, NAME_DI, buf2);			/* set the new title */


	if (pdf_info->Title)									/* set title */
	{
		strcpy (buf, pdf_info->Title);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[TITLE_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, TITLE_DI, buf);

	if (pdf_info->Author)									/* set author */
	{
		strcpy (buf, pdf_info->Author);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[AUTHOR_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, AUTHOR_DI, buf);

	if (pdf_info->Subject)									/* set subject */
	{
		strcpy (buf, pdf_info->Subject);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[SUBJECT_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, SUBJECT_DI, buf);

	if (pdf_info->Keywords)									/* set keywords */
	{
		strcpy (buf, pdf_info->Keywords);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[KEYWORDS_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, KEYWORDS_DI, buf);

	if (pdf_info->Creator)									/* set creator */
	{
		strcpy (buf, pdf_info->Creator);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[CREATOR_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, CREATOR_DI, buf);

	if (pdf_info->Producer)									/* set producer */
	{
		strcpy (buf, pdf_info->Producer);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[PRODUCER_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, PRODUCER_DI, buf);

	if (pdf_info->CreationDate)									/* set creation date */
	{
		strcpy (buf, pdf_info->CreationDate);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[CDATE_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, CDATE_DI, buf);

	if (pdf_info->ModDate)									/* set mod date */
	{
		strcpy (buf, pdf_info->ModDate);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[MDATE_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, MDATE_DI, buf);

	if (pdf_info->Version)									/* set version */
	{
		sprintf (buf, "%i.%i", (pdf_info->Version/10), pdf_info->Version-10*(pdf_info->Version/10));
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[VERSION_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, VERSION_DI, buf);

	if (pdf_info->Trapped)									/* set trapped */
	{
		strcpy (buf, pdf_info->Trapped);
		suspend_small_text (buf, MF_NORMAL, adr_doc_info[TRAPPED_DI].ob_width, 1);
	}
	else
		buf[0] = 0;
	x_set_ob_text (adr_doc_info, TRAPPED_DI, buf);

	
	switch(options.usu)
		{
		case 3:										/* Points	*/
			itoa((int)(page->MediaBox.x2-page->MediaBox.x1), &dummy1[0], 10);
			itoa((int)(page->MediaBox.y2-page->MediaBox.y1), &dummy2[0], 10);
			strcat(dummy1, " x ");
			strcat(dummy1, dummy2);
			strcat(dummy1, " [points] ");
			x_set_ob_text (adr_doc_info, FORMAT_DI, dummy1);
			break;
		case 0:										/* Inches	*/
			sprintf(dummy1, "%.1f x %.1f [in]", (float)(page->MediaBox.x2-page->MediaBox.x1)/(float)72, (float)(page->MediaBox.y2-page->MediaBox.y1)/(float)72);
			x_set_ob_text (adr_doc_info, FORMAT_DI, dummy1);
			break;
		case 1:										/* Centemeters	*/
			sprintf(dummy1, "%.1f x %.1f [cm]", (float)(((page->MediaBox.x2-page->MediaBox.x1)*35277UL)/(float)1000000UL), (float)(((page->MediaBox.y2-page->MediaBox.y1)*35277UL)/(float)1000000UL));
			x_set_ob_text (adr_doc_info, FORMAT_DI, dummy1);
			break;
		case 2:										/* Milimeters	*/
			sprintf(dummy1, "%.1f x %.1f [mm]", (float)(((page->MediaBox.x2-page->MediaBox.x1)*35277UL)/(float)100000UL), (float)(((page->MediaBox.y2-page->MediaBox.y1)*35277UL)/(float)100000UL));
			x_set_ob_text (adr_doc_info, FORMAT_DI, dummy1);
			break;
		}


	switch(pdf_info->PageType)
		{
		case 0:
			sprintf(buf, "%d of single pages", pdf_info->pages->max_to_load);
			x_set_ob_text (adr_doc_info, PAGES_DI, buf);
			break;
		case 1:
			sprintf(buf, "%d of two columns pages", pdf_info->pages->max_to_load);
			x_set_ob_text (adr_doc_info, PAGES_DI, buf);
			break;
		case 2:
			sprintf(buf, "%d of two columns pages (left)", pdf_info->pages->max_to_load);
			x_set_ob_text (adr_doc_info, PAGES_DI, buf);
			break;
		case 3:
			sprintf(buf, "%d of two columns pages (right)", pdf_info->pages->max_to_load);
			x_set_ob_text (adr_doc_info, PAGES_DI, buf);
			break;
		}


	if(pdf_info->encryption==NULL)
		{
		adr_doc_info[PRINTING].ob_state &= ~SELECTED;
		adr_doc_info[MODYFYING].ob_state &= ~SELECTED;
		adr_doc_info[COPYING].ob_state &= ~SELECTED;
		adr_doc_info[FORM].ob_state &= ~SELECTED;
		}
	else
		{
		if(!CheckBit(3, pdf_info->encryption->protection))
			adr_doc_info[PRINTING].ob_state &= ~SELECTED;
		if(CheckBit(4, pdf_info->encryption->protection))
			adr_doc_info[MODYFYING].ob_state &= ~SELECTED;
		if(CheckBit(5, pdf_info->encryption->protection))
			adr_doc_info[COPYING].ob_state &= ~SELECTED;
		if(CheckBit(6, pdf_info->encryption->protection))
			adr_doc_info[FORM].ob_state &= ~SELECTED;
		}


	x_open_dial (adr_doc_info, &dial, 0, 0, 0L);

	for (;;)												/* classic xgem loop... */
	{
		x_form_do (&dial);

		if (x_gem->event & MU_BUTTON)
		{
			obj = *x_gem->object;
			if (obj == OK_DI)
				break;
		}
	}

	x_close_dial (&dial, obj);
}


	/* Cut a too long text and add suspension points */
	/* (This function will not stay here !) */
char *suspend_small_text (char *str, short style, short width, short mode)
{
	short len;

	len = (short)strlen (str) - 3;

	while (x_small_font_width (style, str) > width)
	{
		if (len <= 0)
		{
			str[0] = 0;
			break;
		}

		if (mode)										/* cut at right */
		{
			str[len] = 0;
			strcat (str, "...");
		}
		else											/* cut at left */
		{
			strrev (str);
			str[len] = 0;
			strcat (str, "...");
			strrev (str);
		}
		len --;
	};

	return (str);
}


/*
	text string:
date:	(D:YYYYMMDDHHmmSSOHH' mm' )
name:	/Adobe#20Green Adobe Green
	/PANTONE#205757#20CV PANTONE 5757 CV
	/paired#28#29parentheses paired()parentheses
	/The_Key_of_F#23_Minor The_Key_of_F#_Minor
	/A#42



Title		text string	(Optional; PDF 1.1) The documents title.
Author		text string	(Optional) The name of the person who created the document.
Subject		text string	(Optional; PDF 1.1) The subject of the document.
Keywords	text string	(Optional; PDF 1.1) Keywords associated with the document.
Creator		text string	(Optional) If the document was converted to PDF from another format, the
					   name of the application (for example, Adobe FrameMaker  ) that created the
					   original document from which it was converted.
Producer	text string	(Optional) If the document was converted to PDF from another format, the
					   name of the application (for example, Acrobat Distiller) that converted it to
					   PDF.
CreationDate	date		(Optional) The date the document was created, in human-readable form (see
					   Section 3.8.2, Dates).
ModDate		date		(Optional; PDF 1.1) The date the document was last modified, in human-readable
						form (see Section 3.8.2, Dates).
Trapped		name		(Optional; PDF 1.3) A name object indicating whether the document has
						been modified to include trapping information (see Section 8.6.3, Trapping
						Support):
	True	The document has been fully trapped; no further trapping is
		needed. (Note that this is the name True, not the boolean
		value true.)
	False	The document has not yet been trapped; any desired trap-ping
		must still be done. (Note that this is the name False, not
		the boolean value false.)
	Unknown Either it is unknown whether the document has been
		trapped, or it has been partly but not yet fully trapped; some
		additional trapping may still be needed.
	Default value: Unknown.
The value of this entry may be set automatically by the software creating the
documents trapping information or may only be known to a human opera-tor
and entered manually.

Example 8.1
1 0 obj
<< /Title ( PostScript Language Reference, Third Edition)
/Author ( Adobe Systems Incorporated)
/Creator ( Adobe FrameMaker 5.5.3 for Power Macintosh)
/Producer ( Acrobat Distiller 3.01 for Power Macintosh)
/CreationDate ( D:19970915110347-08'00')
/ModDate ( D:19990209153925-08'00')
>>
endobj
*/
