#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"


int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
char *Read_last_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
char *Read_text(struct files_pdf *);
char *Read_type(struct files_pdf *);


BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

struct picture *Load_picture(struct PDF_Info *pdf_info, char *name);
struct picture *Add_picture(struct picture *dest, struct picture *source);
struct picture *Find_picture(struct picture *pictures, char *name);

void Load_font_object(struct PDF_Info *pdf_info, struct page_resource *resource);


char *resource_command[]={
		"/ExtGState",								/*	dictionary	*/
		"/ColorSpace",							/*	dictionary	*/
		"/Pattern",									/*	dictionary	*/
		"/Shading",									/*	dictionary	*/
		"/XObject",									/*	stream			*/
		"/Font",										/*	dictionary	*/
		"/ProcSet",									/*	array				*/
		"/Properties",							/*	dictionary	*/
		NULL};


BOOLEAN Free_Resource(struct PDF_Info *info)
	{
	info=info;		/* TO DO !!!!	*/
	return(TRUE);
	}







struct page_resource *read_page_resources(struct PDF_Info *info, unsigned int obj)
	{
	struct files_pdf *file = info->file_info;
	struct page_resource *resource=NULL;
	char *line=NULL;
	int keep_going=1;
	struct picture *pict_dummy=NULL;


	resource = calloc (1, sizeof (struct page_resource));
	memset(resource, 0, sizeof (struct page_resource));

	GoToObject(info, obj);

	keep_going=1;

	if(resource && obj>0)
		{

		while(keep_going!=0)
			{
			switch((keep_going=Command2ID(file, resource_command)))
				{
				case RESOURCE_EXTGSTATE:
						resource->ExtGState = file->actual_pos;
						break;

				case RESOURCE_COLORSPACE:
						resource->ColorSpace = file->actual_pos;
						break;

				case RESOURCE_PATTERN:
						resource->Pattern = file->actual_pos;
						break;

				case RESOURCE_SHADING:
						resource->Shading = file->actual_pos;
						break;

				case RESOURCE_XOBJECT:
						resource->XObject = file->actual_pos;
						break;

				case RESOURCE_FONT:
						resource->Font = file->actual_pos;
						break;

				case RESOURCE_PROCSET:
						resource->ProcSet = file->actual_pos;
						break;

				case RESOURCE_PROPERTIES:
						resource->Properties = file->actual_pos;
						break;

				default:
						break;
				}
			}
		}

	if(resource->XObject>0)										/* Are there any external objects?	*/
		{
		file->actual_pos = resource->XObject;

		if(file->buffer[file->actual_pos]=='<' || file->buffer[file->actual_pos+1]=='<')
			{
			if(file->buffer[file->actual_pos]==' ')
				file->actual_pos++;
			while(file->buffer[file->actual_pos]!=' ' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\n')
				file->actual_pos++;
			}
		else
			{
			GoToObject(info, (unsigned int)Read_object_no(file));
			}


		while(file->buffer[file->actual_pos]!='/')
			file->actual_pos++;

		while(file->buffer[file->actual_pos]!='>' && strstr(&file->buffer[file->actual_pos], "0 R")<strstr(&file->buffer[file->actual_pos], ">>"))
			{
			line = &file->buffer[file->actual_pos];
			while(file->buffer[file->actual_pos]!=' ')
				file->actual_pos++;

			file->actual_pos++;

			GoToObject(info, (unsigned int)atol(&file->buffer[file->actual_pos]));

			pict_dummy = Load_picture(info, line);
			resource->pictures = Add_picture(resource->pictures, pict_dummy);
			free(pict_dummy);
			
			GoBack(info);

			file->actual_pos++;

			while(file->buffer[file->actual_pos]!='/')
				{
				if(file->buffer[file->actual_pos]=='>')
					break;
				file->actual_pos++;
				}
			}
		}

	if(resource->Font>0)
		{
		file->actual_pos = resource->Font;
		if(file->buffer[file->actual_pos+1]=='<')
			file->actual_pos++;
		else
			{
			if(file->buffer[file->actual_pos]==' ')
				file->actual_pos++;
			GoToObject(info, (unsigned int)Read_object_no(file));
			}
		Load_font_object(info, resource);
		GoBack(info);
		}

	GoBack(info);
	return(resource);
}