#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"
#include	"mypdf.h"


char *Read_command(struct files_pdf *);
char *read_command(int );
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
int read_object_no(int );
BOOLEAN Check_last_line(struct PDF_Info *PDF_Info);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
long find_object_number (struct file_position *, int , unsigned int );
long find_object_position (struct PDF_Info *, int );

BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);

void Add_entry2steps(int value);

unsigned long Find_PDF_info (struct PDF_Info *);

extern struct opt options;

extern struct Root_obj *read_root_obj(struct PDF_Info *info);

extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];
extern short wh_status;


char *trailer_commands[]={
		"/Size",
		"/Info",
		"/Encrypt",
		"/Root",
		"/Prev",
		"/ID",
		NULL};



struct PDF_Trailer *read_trailer(struct PDF_Info *info)
	{
	struct files_pdf *file = info->file_info;
	struct PDF_Trailer *trailer=NULL;
	int keep_going=1;
	unsigned long prev_pos=0;
	char *line=NULL;

	trailer = calloc (1, sizeof (struct PDF_Trailer));

	while(file->buffer[file->actual_pos]=='<')
		file->actual_pos++;

	if(trailer)
		{

		while(keep_going!=0)
			{
			switch((keep_going=Command2ID(file, trailer_commands)))
				{
				case TRAILER_SIZE:
							trailer->Size = Read_object_no(file);
							break;
				case INFO_OBJECT:
							trailer->Info_object = Read_object_no(file);
							info->Info_object = trailer->Info_object;
							Add_entry2steps(STEPS_INFO);
							break;
				case ENCRYPT_OBJECT:
							trailer->Encrypt_object = Read_object_no(file);
					/* To Change when the encryption routines will work	*/
							info->encryption = read_encryption(info, trailer->Encrypt_object);
							x_gem_alert("[1][Sorry, unsuported file type... (Encryption)][Oops]", 0L);
							Change_status(STATUS_WIN_CLOSE, 0, 0);
							free(trailer);
					/*			*/
							return(NULL);
						/*	break;	*/
				case ROOT_OBJECT:
							trailer->Root_object = Read_object_no(file);
							break;
				case PREV_OBJECT:
							prev_pos = trailer->Prev_object = Read_object_no(file);
							trailer->Prev_object_position = Read_object_no(file);
							break;
				case TRAILER_ID:
							break;
				default:
							;
							break;
				}
			}

		if(info->trailer==NULL)
			info->trailer = trailer;
		else
			{																												/* It is possible that there is more then one or two trailer dictionarys	*/
			if(trailer->Info_object>0)
				info->trailer->Info_object = trailer->Info_object;
			if(trailer->Encrypt_object>0)
				info->trailer->Encrypt_object = trailer->Encrypt_object;
			if(trailer->Root_object>0)
				info->trailer->Root_object = trailer->Root_object;
			if(trailer->Prev_object>0)
				info->trailer->Prev_object = trailer->Prev_object;
			free(trailer);
			trailer = info->trailer;
			}

		if(prev_pos)
			{
			file->actual_pos = prev_pos;
			if(trailer->objects_list_position2==0)
				trailer->objects_list_position2 = file->actual_pos;
			else if(trailer->objects_list_position3==0)
				trailer->objects_list_position3 = file->actual_pos;
			else if(trailer->objects_list_position4==0)
				trailer->objects_list_position4 = file->actual_pos;
			else if(trailer->objects_list_position5==0)
				trailer->objects_list_position5 = file->actual_pos;
			else if(trailer->objects_list_position6==0)
				trailer->objects_list_position6 = file->actual_pos;

			if(Load_objects(info, 1)==TRUE)													/* Load previous objects	*/
				{
				line = Read_prev_line(file);													/* Do we have to load another one trailer?	*/
				read_trailer(info);
				free(line);
				}
			}

		if(trailer->Root_object && !info->Root_obj)
			info->Root_obj = read_root_obj(info);


		if(trailer->Encrypt_object>0 && options.work_mode&LOAD_ENCRYPT && trailer->Encrypt_object_position==0)
			{
			trailer->Encrypt_object_position = find_object_position(info, (unsigned int)trailer->Encrypt_object);
			read_encryption(info, trailer->Encrypt_object);
			}

		return(info->trailer);
		}
	return(NULL);
}


struct PDF_Trailer *find_trailer(struct PDF_Info *info)
{
	char *line;
	unsigned long pos1;

	Change_status(STATUS_PDF_READ_TRAILER, 0, 0);

	if(info->file_info->buffer || info->file_info->handle>0)
	{
		if(Check_last_line(info)==FALSE)
			{
			line = Read_prev_line(info->file_info);
			while(strcmp(line, "%%EOF")!=0)
				{
				if(strcmp(line, "%%EOF")==0)
					break;
				line = Read_prev_line(info->file_info);
				info->file_info->actual_pos -= strlen(line);
				}
			info->file_info->actual_pos -= 3;
			}

		line = Read_prev_line(info->file_info);		/* Reads the position of the trailer														*/
		pos1 = atol(line);
		if(line)
			free (line);
	}

	info->file_info->actual_pos = (unsigned long)pos1;
	info->pos_xref = (unsigned long)pos1;

	if(options.work_mode>0)		/* Should I load everything?	*/
		Load_objects(info, 0);
	else											/* or just the info object?		*/
		pos1 = Find_PDF_info(info);


	if(options.work_mode>=0)		/* Should I load everything?	*/
		return(read_trailer(info));
	else											/* or just the info object?		*/
		{
		struct PDF_Trailer *trailer;

		trailer = calloc (1, sizeof (struct PDF_Trailer));
		trailer->Info_object_position = pos1;
		return(trailer);
		}
}
