typedef struct annotations
	{ 
	int type;												/*	name				(Optional) The type of PDF object that this dictionary describes; if present,
																									must be Annot for an annotation dictionary.	*/
	int subtype;										/*	name				(Required) The type of annotation that this dictionary describes; see
																									Table 7.13 on page 408 for specific values.	*/
	long p;													/*	dictionary	(Optional; PDF 1.3; not used in FDF files) An indirect reference to the page
																									object with which this annotation is associated.	*/
	struct Rectangle rect;					/*	rectangle		(Required) The annotation rectangle, defining the location of the annotation
																									on the page in default user space units.	*/
	long M;													/*	date or string (Optional; PDF 1.1) The date and time when the annotation was last modi-
																									fied. The preferred format is a date string as described in Section 3.8.2,
																									Dates, but viewer applications should be prepared to accept and display a
																									string in any format. (See implementation note 51 in Appendix H.)	*/
	int F;													/* integer			(Optional; PDF 1.1) A set of flags specifying various characteristics of the annotation
																									(see Section 7.4.2, Annotation Flags). Default value: 0.	*/
	int Border[10];									/*	array				(Optional) An array specifying the characteristics of the annotations border.
																									The border is specified as a rounded rectangle.	*/


/* LINK ANNOTATION	*/
	long Dest;											/*	array, name,	(Optional; not permitted if an A entry is present)	*/
	long A;													/*	destination to be displayed
																					or string when the annotation is activated (see Section 7.2.1, Destinations; see also
																					implementation note 58 in Appendix H).	*/
	char H;													/*	name					(Optional; PDF 1.2) The annotations highlighting mode, the visual effect to be
																					used when the mouse button is pressed or held down inside its active area:	*/
	BOOLEAN N;											/*	(None)				No highlighting.	*/
	BOOLEAN I;											/*	(Invert)			Invert the contents of the annotations bounding box.	*/
	BOOLEAN O;											/*	(Outline)			Invert the annotations border.	*/
	BOOLEAN P;											/*	(Push)				Display the annotations down appearance, if any (see
																										Section 7.4.4, Appearance Streams). If no down appearance is de-
																										fined, offset the contents of the annotations bounding box to appear as
																										if it were being pushed below the surface of the page.
																										A highlighting mode other than P overrides any down appearance defined for
																										the annotation. Default value: I.
																										Note: In PDF 1.1, highlighting is always done by inverting colors inside the annotations
																										bounding box.	*/
	long PA;												/*	dictionary		(Optional; PDF 1.3) A URI action (see URI Actions on page 428) formerly
																										associated with this annotation. When Web Capture (Section 8.5, Web Capture)
																										changes an annotation from a URI to a go-to action (Go-To Actions
																										on page 425), it uses this entry to save the data from the original URI action so
																										that it can be changed back in case the target page for the GoTo action is subsequently
																										deleted.	*/
	int number;											/*	loaded = how many annotations do we have
																			number = the number of the actual annotation	*/
	};