extern char *threads_commands[];
extern char *bead_dict_commands[];

#define BEAD_DICT_TYPE	1
#define BEAD_DICT_T			2
#define BEAD_DICT_N			3
#define BEAD_DICT_V			4
#define BEAD_DICT_P			5
#define BEAD_DICT_R			6

struct	PDF_Bead_dict
	{

	char Type[256];			/*	name			(Optional) The type of PDF object that 
													this dictionary describes; if present, must be 
													Bead for a bead dictionary. */

	long T;							/* dictionary		(Required for the first bead of a 
												thread; optional for all others; must be an 
												indirect reference) The thread to which this bead 
												belongs. Note: In PDF 1.1, this entry is permitted 
												only for the first bead of a thread. In PDF 1.2
												and higher, it is permitted for any bead but
												required only for the first.		*/

	long N;							/* dictionary		(Required; must be an indirect 
													reference) The next bead in the thread. In the 
													last bead, this entry points to the first. */

	long V;							/*	dictionary (Required; must be an indirect 
													reference) The previous bead in the thread. In 
													the first bead, this entry points to the last. */
	long P;							/* dictionary		(Required; must be an indirect 
													reference) The page object representing the page 
													on which this bead appears.	*/
	struct Rectangle R;	/* rectangle		(Required) A rectangle specifying 
													the location of this bead on the page.	*/
	struct	PDF_Bead_dict *next;
	struct	PDF_Bead_dict *prev;
	};



#define THREADS_TYPE	1
#define THREADS_F			2
#define THREADS_I			3


struct PDF_Threads
	{
	struct Page_tree *obj_list;			/* List of threads as a list of objects	*/
	int threads_no;									/* How many threads are there?					*/

	struct Threads
		{
		char Type[256];								/* name			(Optional) The type of PDF object that 
																			this dictionary describes; if present, must be 
																			Thread for a thread dictionary. */

		long F;												/* dictionary		(Required; must be an indirect 
																			reference) The first bead in the thread.	*/
		struct docu_info *I;					/* (Optional) A thread information dictionary 
																			containing information about the thread, such as 
																			its title, author, and creation date. The 
																			contents of this dictionary are similar to those 
																			of the document information dictionary
																			(see Section 8.2, Document Information 
																			Dictionary). */
		struct PDF_Bead_dict *first_bead;
		}*threads;
	};


/*
Example 7.4 shows a thread with three beads.
Example 7.4
22 0 obj
<< /F 23 0 R
/I << /Title ( Man Bites Dog) >>
>>
endobj
23 0 obj
<< /T 22 0 R
/N 24 0 R
/V 25 0 R
/P 8 0 R
/R [ 158 247 318 905]
>>
endobj
24 0 obj
<< /T 22 0 R
/N 25 0 R
/V 23 0 R
/P 8 0 R
/R [ 322 246 486 904]
>>
endobj
25 0 obj
<< /T 22 0 R
/N 23 0 R
/V 24 0 R
/P 10 0 R
/R [ 157 254 319 903]
>>
endobj
*/